<div class="work-time-reports-list mb-5">
  <div class="container">

    <h1 class="mat-h1">Ewidencja czasu pracy</h1>
    <mat-divider class="mb-2"></mat-divider>

    <mat-card>
      <div class="search-div">
        <mat-form-field class="search-form-field">
          <input matInput [(ngModel)]="searchKey" placeholder="Wyszukaj raport czasu pracy pracownika" autocomplete="off"
                 (keyup)="applyFilter()">
          <button mat-button matSuffix mat-icon-button aria-label="Wyczyść" *ngIf="searchKey" (click)="onSearchClear()">
            <mat-icon>close</mat-icon>
          </button>
        </mat-form-field>
      </div>
      <div class="mat-elevation-z8">
        <mat-table mat-table [dataSource]="workTimeRecordsDataSource" matSort>

          <ng-container matColumnDef="createdBy">
            <mat-header-cell mat-header-cell *matHeaderCellDef mat-sort-header> Pracownik</mat-header-cell>
            <mat-cell mat-cell *matCellDef="let element"> {{element?.createdBy?.data?.firstName}}
              {{element?.createdBy?.data?.lastName}}
            </mat-cell>
          </ng-container>

          <ng-container matColumnDef="project">
            <mat-header-cell mat-header-cell *matHeaderCellDef mat-sort-header> Projekt</mat-header-cell>
            <mat-cell mat-cell
                      *matCellDef="let element"> {{element?.project?.name ? element?.project?.name : '--raport bez projektu--'}} </mat-cell>
          </ng-container>

          <ng-container matColumnDef="message">
            <mat-header-cell mat-header-cell *matHeaderCellDef> Treść</mat-header-cell>
            <mat-cell mat-cell *matCellDef="let element"> {{element?.message}} </mat-cell>
          </ng-container>

          <ng-container matColumnDef="type">
            <mat-header-cell mat-header-cell *matHeaderCellDef mat-sort-header> Typ</mat-header-cell>
            <mat-cell mat-cell *matCellDef="let element">
              <ng-container *ngIf="element?.type === 'nominal'">
                Nominalny
              </ng-container>
              <ng-container *ngIf="element?.type === 'nominalCopyright'">
                Nominalny/Prawa Autorskie
              </ng-container>
              <ng-container *ngIf="element?.type === 'overtime50'">
                Nadgodziny 50%
              </ng-container>
              <ng-container *ngIf="element?.type === 'overtime100'">
                Nadgodziny 100%
              </ng-container>
            </mat-cell>
          </ng-container>

          <ng-container matColumnDef="time">
            <mat-header-cell mat-header-cell *matHeaderCellDef mat-sort-header> Czas</mat-header-cell>
            <mat-cell mat-cell *matCellDef="let element"> {{element?.time}} g.</mat-cell>
          </ng-container>

          <ng-container matColumnDef="reportForDate">
            <mat-header-cell mat-header-cell *matHeaderCellDef mat-sort-header> Raport za dzień</mat-header-cell>
            <mat-cell mat-cell *matCellDef="let element"> {{element?.reportForDate | date: 'd/MM/yyyy'}} </mat-cell>
          </ng-container>

          <ng-container matColumnDef="createdAt">
            <mat-header-cell mat-header-cell *matHeaderCellDef mat-sort-header> Utworzono</mat-header-cell>
            <mat-cell mat-cell *matCellDef="let element"> {{element?.createdAt | date: 'd/MM/yyyy, h:mm'}} </mat-cell>
          </ng-container>

          <ng-container matColumnDef="updatedAt">
            <mat-header-cell mat-header-cell *matHeaderCellDef mat-sort-header> Edytowano</mat-header-cell>
            <mat-cell mat-cell *matCellDef="let element"> {{element?.updatedAt | date: 'd/MM/yyyy, h:mm'}} </mat-cell>
          </ng-container>

          <ng-container matColumnDef="loading">
            <mat-footer-cell *matFooterCellDef>
              Ładowanie danych...
            </mat-footer-cell>
          </ng-container>

          <ng-container matColumnDef="noData">
            <mat-footer-cell *matFooterCellDef>
              Aktualnie nie został złożony jeszcze żaden raport czasu pracy.
            </mat-footer-cell>
          </ng-container>

          <mat-header-row mat-header-row *matHeaderRowDef="displayedColumns"></mat-header-row>
          <mat-row mat-row *matRowDef="let row; columns: displayedColumns;"></mat-row>

          <mat-footer-row *matFooterRowDef="['loading']"
                          [ngClass]="{'none':workTimeRecordsDataSource!=null}"></mat-footer-row>
          <mat-footer-row *matFooterRowDef="['noData']"
                          [ngClass]="{'none':!(workTimeRecordsDataSource!=null && workTimeRecordsDataSource.data.length==0)}"></mat-footer-row>
        </mat-table>

        <mat-paginator [pageSizeOptions]="[5, 10, 25, 100]" [pageSize]="10" showFirstLastButtons></mat-paginator>

      </div>
    </mat-card>

  </div>
</div>
